/* This file is part of Eclat.
   Copyright (C) 2012 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#include "eclat.h"

static void
parse_options(int argc, char *argv[], int *index)
{
	static char *resource_types[] = {
		"customer-gateway",
		"dhcp-options",
		"image",
		"instance",
		"internet-gateway",
		"network-acl",
		"reserved-instances",
		"route-table",
		"security-group",
		"snapshot",
		"spot-instances-request",
		"subnet",
		"volume",
		"vpc",
		"vpn-connection",
		"vpn-gateway",
		NULL
	};

	static struct filter_descr filters[] = {
		{ "key",           FILTER_STRING },
		{ "resource-id",   FILTER_STRING },
		{ "resource-type", FILTER_ENUM, resource_types },
		{ "value",         FILTER_STRING },
		{ NULL }
	};

	available_filters = filters;
	generic_proginfo->print_help_hook = list_filters;
	return generic_parse_options("eclat describe-tags",
				     "List tags and their values",
				     argc, argv, index);
}

int
eclat_describe_tags(CURL *curl, int argc, char **argv)
{
	int i;
	struct ec2_query *q;
	
	parse_options(argc, argv, &i);
	argv += i;
	argc -= i;
	translate_resource_ids(argc, argv);

	q = describe_query_create(curl, "DescribeTags", argc, argv, NULL);
	return eclat_send_query(curl, q);
}
